package com.cit.sellfan.ui;
//usa 	.v-label-withborder 	dal .scss
import java.text.NumberFormat;

import com.vaadin.shared.ui.MarginInfo;
import com.vaadin.shared.ui.label.ContentMode;
import com.vaadin.ui.Alignment;
import com.vaadin.ui.Button;
import com.xdev.ui.XdevButton;
import com.xdev.ui.XdevHorizontalLayout;
import com.xdev.ui.XdevLabel;

public class DoubleStepper extends XdevHorizontalLayout {
	private double minValue = 0.;
	private double maxValue = 999999999.;
	private double step = 1.;
	private double value = 0.;
	private final NumberFormat fmtNd = NumberFormat.getInstance();
	private int nDecinali = 2;

	/**
	 * 
	 * 
	 */
	public DoubleStepper() {
		super();
		this.initUI();
		this.fmtNd.setMinimumFractionDigits(0);
		this.fmtNd.setMaximumFractionDigits(this.nDecinali);
		this.fmtNd.setGroupingUsed(false);
		this.labelValue.setValue("<center>" + this.fmtNd.format(this.value));
	}

	public void setMin(final double minValueIn) {
		this.minValue = minValueIn;
	}

	public void setMax(final double maxValueIn) {
		this.maxValue = maxValueIn;
	}

	public void setStep(final double stepIn) {
		if (stepIn <= 0.) {
			return;
		}
		this.step = stepIn;
	}

	public void setValue(double valueIn) {
		if (valueIn < this.minValue) {
			valueIn = this.minValue;
		}
		if (valueIn > this.maxValue) {
			valueIn = this.maxValue;
		}
		this.value = valueIn;
		this.labelValue.setValue("<center>" + this.fmtNd.format(this.value));
	}

	public void setNDecimali(final int nDecinaliIn) {
		if (nDecinaliIn <= 0.) {
			return;
		}
		this.nDecinali = nDecinaliIn;
	}

	public double getValue() {
		return this.value;
	}

	/**
	 * Event handler delegate method for the {@link XdevButton} {@link #buttonMeno}.
	 *
	 * @see Button.ClickListener#buttonClick(Button.ClickEvent)
	 * @eventHandlerDelegate Do NOT delete, used by UI designer!
	 */
	private void buttonMeno_buttonClick(final Button.ClickEvent event) {
		if (this.value - this.step >= this.minValue) {
			this.value -= this.step;
			this.labelValue.setValue("<center>" + this.fmtNd.format(this.value));
		}
	}

	/**
	 * Event handler delegate method for the {@link XdevButton} {@link #buttonPiu}.
	 *
	 * @see Button.ClickListener#buttonClick(Button.ClickEvent)
	 * @eventHandlerDelegate Do NOT delete, used by UI designer!
	 */
	private void buttonPiu_buttonClick(final Button.ClickEvent event) {
		if (this.value + this.step <= this.maxValue) {
			this.value += this.step;
			this.labelValue.setValue("<center>" + this.fmtNd.format(this.value));
		}
	}

	/*
	 * WARNING: Do NOT edit!<br>The content of this method is always regenerated by
	 * the UI designer.
	 */
	// <generated-code name="initUI">
	private void initUI() {
		this.buttonMeno = new XdevButton();
		this.labelValue = new XdevLabel();
		this.buttonPiu = new XdevButton();
	
		this.setSpacing(false);
		this.setMargin(new MarginInfo(false));
		this.buttonMeno.setCaption("<<");
		this.buttonMeno.setStyleName("small");
		this.labelValue.setStyleName("withborder");
		this.labelValue.setValue("<center>0");
		this.labelValue.setContentMode(ContentMode.HTML);
		this.buttonPiu.setCaption(">>");
		this.buttonPiu.setStyleName("small");
	
		this.buttonMeno.setWidth(-1, Unit.PIXELS);
		this.buttonMeno.setHeight(18, Unit.PIXELS);
		this.addComponent(this.buttonMeno);
		this.setComponentAlignment(this.buttonMeno, Alignment.TOP_RIGHT);
		this.labelValue.setWidth(90, Unit.PIXELS);
		this.labelValue.setHeight(18, Unit.PIXELS);
		this.addComponent(this.labelValue);
		this.buttonPiu.setWidth(-1, Unit.PIXELS);
		this.buttonPiu.setHeight(18, Unit.PIXELS);
		this.addComponent(this.buttonPiu);
		this.setSizeUndefined();
	
		this.buttonMeno.addClickListener(event -> this.buttonMeno_buttonClick(event));
		this.buttonPiu.addClickListener(event -> this.buttonPiu_buttonClick(event));
	} // </generated-code>

	// <generated-code name="variables">
	private XdevButton buttonMeno, buttonPiu;
	private XdevLabel labelValue;
	// </generated-code>

}
